#!/bin/sh
export LC_ALL=en_US.utf-8

size=1024
iterations=1000

if test $# -ge 1 ; then
    size=$1
fi
if test $# -ge 2 ; then
    iterations=$2
fi

echo "------------------"
echo "size=$size"
echo "iterations=$iterations"
echo "------------------"
./build/bin/julia_cpu.exe -i $iterations -w $size -h $size >tmp.txt
cpu=`cat tmp.txt | grep "^cpu time" | cut -d'|' -f3 | awk '{printf("%7.3f", $1);}'`
echo "cpu   =$cpu s"

./build/bin/julia_gpu_1.exe -i $iterations -w $size -h $size >tmp.txt
gpu_v1=`cat tmp.txt | grep "^cpu time" | cut -d'|' -f3 | awk '{printf("%7.3f", $1);}'`
echo "gpu_v1=$gpu_v1 s"

./build/bin/julia_gpu_2.exe -i $iterations -w $size -h $size >tmp.txt
gpu_v2=`cat tmp.txt | grep "^cpu time" | cut -d'|' -f3 | awk '{printf("%7.3f", $1);}'`
echo "gpu_v2=$gpu_v2 s"

echo "------------------"
echo "ratio cpu/gpu_v2"
echo "scale=4;$cpu/$gpu_v2" | bc

rm tmp.txt